var buttonModule = require("tns-core-modules/ui/button");
var observable = require("tns-core-modules/data/observable");
var camera = require("nativescript-camera");
var imageModule = require("ui/image");
var Kinvey = require('kinvey-nativescript-sdk').Kinvey;
var imageSource = require("image-source");
var fs = require("file-system");

exports.pageLoaded = function () {
    Kinvey.init({
        appKey: 'kid_SkjpRhCbW',
        appSecret: '421a7f6e3fd748b6bce12d2f7d6fd717'
    });

    Kinvey.ping()
        .then(function (response) {
            console.log('Kinvey Ping Success. Kinvey Service is alive, version: ' + response.version + ', response: ' + response.kinvey);
        })
        .catch(function (error) {
            console.log('Kinvey Ping Failed. Response: ' + error.description);
        });

    const activeUser = Kinvey.User.getActiveUser();
    if (!activeUser) {
        Kinvey.User.login('Martin', '123');
    }
};

exports.buttonTap = function buttonTap() {
    camera.requestPermissions();
    camera.takePicture()
        .then(function (imageAsset) {
            console.log("Result is an image asset instance");
            console.dir(imageAsset);
            
            console.log('Uploading image');

            var filePath = imageAsset.android;
            console.log('exists: ' + fs.File.exists(filePath));

            var imageFile = fs.File.fromPath(filePath);
            console.dir(imageFile);
            var fileContent = imageFile.readSync();

            var metadataTrue = {
                filename: imageFile.name,
                mimeType: 'image/jpeg',
                size: fileContent.length,
                public: true
            }
           
            Kinvey.Files.upload(imageFile, metadataTrue)
                .then(function (file) {
                    console.log('File uploaded');
                    console.log(JSON.stringify(file));
                })
                .catch(function (error) {
                    console.log('Upload error: ' + error.message);
                });
        }).catch(function (err) {
            console.log("Error -> " + err.message);
        });
}